<?php

namespace Drupal\mcapi_bursers;

use Drupal\mcapi\Entity\Storage\WalletStorage;
use Drupal\user\Entity\User;
use Drupal\mcapi\Entity\Access\TransactionAccessControlHandler;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;

/**
 * Defines an access controller option for the mcapi_transaction entity.
 */
class BurserTransactionAccessControlHandler extends TransactionAccessControlHandler {

  /**
   * @var Drupal\mcapi\Entity\Query\WalletQuery
   */
  protected $walletQuery;

  /**
   * @var Drupal\Core\Messenger\Messenger
   */
  protected $messenger;


  /**
   * {@inheritdoc}
   */
  public function checkCreateAccess(AccountInterface $account, array $context, $entity_bundle = NULL) {
    if ($account->hasPermission('create 3rdparty transaction')) {
      $result = AccessResult::allowed();
    }
    elseif (WalletStorage::hasWallet(User::load($account->id()))) {
      $result = AccessResult::allowed();
    }
    elseif ($this->walletQuery->condition('bursers', $account->id())->execute()) {
      $result = AccessResult::allowed();
    }
    else {
      $result = AccessResult::forbidden('User has no wallet, nor is burser to any wallet.');
    }
    return $result->cachePerUser();
  }
}
