<?php

use Drupal\mcapi_signatures\RemoteSignAccess;
use Drupal\Core\Url;

/**
 * Implements hook_token_info_alter().
 */
function mcapi_signatures_token_info_alter(&$data) {
  $data['tokens']['xaction']['sign-link'] = [
    'name' => t("Signature link"),
    'description' => t("A unique url for a user to sign a transaction."),
  ];
}
/**
 * Implements hook_tokens().
 */
function mcapi_signatures_tokens($type, $tokens, array $data, array $options, $bubbleable_metadata) {
  $replacements = [];
  if ($type == 'xaction' and isset($tokens['sign-link'])) {
    // This link is intended for mails so it is always external.
    $replacements['[xaction:sign-link]'] = Url::fromRoute(
      'mcapi.signatures.anonsign',
      [
        'uid' => $data['user']->id(),
        'mcapi_transaction' => $data['xaction']->serial->value,
        'hash' => RemoteSignAccess::generateHash($data['user']->id(), $data['xaction']->serial->value),
      ],
      ['absolute' => TRUE]
    )->toString();
  }
  return $replacements;
}

