<?php

namespace Drupal\mcapi_signatures\Plugin\Action;

use Drupal\mcapi\Entity\TransactionInterface;
use Drupal\mcapi\Plugin\TransactionActionBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Changes the transaction state from pending to 'done'.
 *
 * @Action(
 *   id = "mcapi_transaction.signoff_action",
 *   label = @Translation("Sign off a transaction"),
 *   type = "mcapi_transaction"
 * )
 */
class SignOff extends TransactionActionBase {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $elements = parent::buildConfigurationForm($form, $form_state);
    $elements['states'] = [
      '#type' => 'value',
      '#value' => ['pending' => 'pending'],
    ];
    return $elements;
  }

  /**
   * {@inheritdoc}
   */
  public function execute($transaction = NULL) {
    mcapi_signature_service($transaction)->signOff();
    parent::execute($transaction);
  }

  protected function accessOp(TransactionInterface $transaction, AccountInterface $account = NULL) {
    if ($account->id() == 1) {
      return TRUE;
    }
    return $this->transactionRelativeManager
      ->isRelative($transaction, $account, $this->configuration['access']);
  }

}
