<?php

namespace Drupal\mcapi\Entity\Views;

use Drupal\views\EntityViewsData;

/**
 * Views data for wallet entity.
 */
class WalletViewsData extends EntityViewsData {

  /**
   * {@inheritdoc}
   */
  public function getViewsData() {
    $data = parent::getViewsData();
    $data['mcapi_wallet']['wid']['field']['id'] = 'mcapi_entity';

    $data['mcapi_wallet']['balance'] = [
      'title' => $this->t('Balance'),
      'help' => $this->t("Sum of all this wallet's credits minus debits"),
      'field' => [
        'id' => 'computed_worths',
      ]
    ];
    $data['mcapi_wallet']['volume'] = [
      'title' => $this->t('Volume of transactions'),
      'help' => $this->t("Sum of all this wallet's transactions"),
      'field' => [
        'id' => 'computed_worths',
      ]
    ];
    $data['mcapi_wallet']['gross_in'] = [
      'title' => $this->t('Gross income'),
      'help' => $this->t("Sum of all this wallet's income ever"),
      'field' => [
        'id' => 'computed_worths',
      ]
    ];
    $data['mcapi_wallet']['gross_out'] = [
      'title' => $this->t('Gross expenditure'),
      'help' => $this->t("Sum of all this wallet's outgoings ever"),
      'field' => [
        'id' => 'computed_worths',
      ]
    ];
    $data['mcapi_wallet']['trades'] = [
      'title' => $this->t('Number of trades'),
      'help' => $this->t("Number of transactions involving this wallet"),
      'field' => [
        'id' => 'mcapi_dummy',
      ]
    ];
    $data['mcapi_wallet']['partners'] = [
      'title' => $this->t('Partner count'),
      'help' => $this->t("Number of unique trading partners"),
      'field' => [
        'id' => 'mcapi_dummy',
      ]
    ];

    // This allows us to do group queries such as find the balance per wallet.
    $data['mcapi_transactions_index']['table']['join'] = [
      'mcapi_wallet' => [
        'left_field' => 'wid',
        'field' => 'wallet_id',
        'required' => TRUE,
      ],
    ];

    return $data;
  }
}
