<?php

namespace Drupal\mcapi\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Plugin\Field\FieldFormatter\EntityReferenceLabelFormatter;
use Drupal\Core\Field\EntityReferenceFieldItemListInterface;

/**
 * Plugin implementation of the formatter for wallet holder labels (in transactions)
 *
 * @FieldFormatter(
 *   id = "wallet_holder",
 *   label = @Translation("Wallet holder"),
 *   field_types = {
 *     "wallet_reference"
 *   }
 * )
 *
 */
class TransactionWalletHolderFormatter extends EntityReferenceLabelFormatter {

  protected function getEntitiesToView(EntityReferenceFieldItemListInterface $items, $langcode) {
    $entities = [];
    foreach ($items as $delta => $item) {
      // Ignore items where no entity could be loaded in prepareView().
      if (!empty($item->_loaded)) {
        // This is the wallet entity, but we want its parent.
        $entity = $item->entity->getHolder();
        $entity->_referringItem = $item;
        $entities[$delta] = $entity;
      }
    }
    return $entities;
  }


}
