<?php

namespace Drupal\mcapi\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Plugin\Field\FieldFormatter\EntityReferenceLabelFormatter;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\dynamic_entity_reference\Plugin\Field\FieldFormatter\DynamicEntityReferenceFormatterTrait;

/**
 * Plugin implementation of the 'dynamic entity reference label' formatter.
 *
 * @FieldFormatter(
 *   id = "dynamic_entity_reference_label_fallback",
 *   label = @Translation("Label (with fallback)"),
 *   description = @Translation("Display the label of the referenced entities, with fallback for orphans"),
 *   field_types = {
 *     "dynamic_entity_reference"
 *   }
 * )
 */
class WalletHolderLabelFormatter extends EntityReferenceLabelFormatter {

  use DynamicEntityReferenceFormatterTrait;

  public function viewElements(FieldItemListInterface $items, $langcode) {
    if (!$items->entity) {
      $items->applyDefaultValue();
      $this->prepareView([$items]);
    }
    return parent::viewElements($items, $langcode);
  }
}
